<template>
  <div>
    <b-row>
      <b-colxx xxs="12">
        <div class="top-right-button-container">
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalnew
            variant="success"
            size="lg"
            class="top-right-button"
            >Add</b-button
          >
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalbasic
            variant="danger"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length <= 0"
            >delete</b-button
          >
          <b-button
            v-if="currentUser && currentUser.role === true"
            v-b-modal.modalright
            variant="primary"
            size="lg"
            class="top-right-button"
            :disabled="bootstrapTable.selected.length != 1"
            >edit</b-button
          >
          <b-modal id="modalbasic" ref="modalbasic" :title="'Suppression'">
            Do you really want to delete the
            {{ bootstrapTable.selected.length }} selected Rss(es) ?
            <template slot="modal-footer">
              <b-button variant="primary" @click="deleteRsses()" class="mr-1"
                >Confirmer</b-button
              >
              <b-button variant="secondary" @click="hideModal('modalbasic')"
                >Annuler</b-button
              >
            </template>
          </b-modal>
          <b-modal
            id="modalright"
            ref="modalright"
            :title="'Modification rss'"
            class="modal-right"
          >
            <b-form v-if="bootstrapTable.selected[0]">
              <b-form-group :label="'Site'">
                <b-form-input v-model="bootstrapTable.selected[0].site" />
              </b-form-group>
              <b-form-group :label="'Link'">
                <b-form-input v-model="bootstrapTable.selected[0].link" />
              </b-form-group>
              <b-form-group :label="'Interval'">
                <b-form-input
                  type="number"
                  v-model="bootstrapTable.selected[0].interval"
                />
              </b-form-group>
            </b-form>

            <template slot="modal-footer">
              <b-button
                variant="outline-secondary"
                @click="hideModal('modalright')"
                >cancel</b-button
              >
              <b-button variant="primary" @click="updateRsses()" class="mr-1"
                >validate</b-button
              >
            </template>
          </b-modal>

          <b-modal
            id="modalnew"
            ref="modalnew"
            :title="'Ajouter un rss'"
            class="modal-right"
          >
            <b-form>
              <b-form-group :label="'Site'">
                <b-form-input v-model="newRss.site" />
              </b-form-group>
              <b-form-group :label="'Link'">
                <b-form-input v-model="newRss.link" />
              </b-form-group>
              <b-form-group :label="'Interval'">
                <b-form-input type="number" v-model="newRss.interval" />
              </b-form-group>
            </b-form>

            <template slot="modal-footer">
              <b-button
                variant="outline-secondary"
                @click="hideModal('modalright')"
                >cancel</b-button
              >
              <b-button variant="primary" @click="addRss()" class="mr-1"
                >Add</b-button
              >
            </template>
          </b-modal>
        </div>

        <h1>All Rsses</h1>
        <div class="separator mb-5"></div>
      </b-colxx>
    </b-row>
    <b-row>
      <b-colxx xxs="12">
        <b-table
          ref="custom-table"
          class="vuetable"
          sort-by="title"
          sort-desc.sync="false"
          @row-selected="rowSelected"
          selectable
          :select-mode="bootstrapTable.selectMode"
          :current-page="currentPage"
          selectedVariant="primary"
          :fields="bootstrapTable.fields"
          :items="items"
          v-if="currentUser && currentUser.role === true"
        >
          <template slot="status" slot-scope="data">
            <b-badge class="mb-1" :variant="data.item.statusColor">{{
              data.value
            }}</b-badge>
          </template>
        </b-table>
        <b-pagination
          size="sm"
          align="center"
          :total-rows="items.length"
          :per-page="perPage"
          v-model="currentPage"
        >
          <template v-slot:next-text>
            <i class="simple-icon-arrow-right" />
          </template>
          <template v-slot:prev-text>
            <i class="simple-icon-arrow-left" />
          </template>
          <template v-slot:first-text>
            <i class="simple-icon-control-start" />
          </template>
          <template v-slot:last-text>
            <i class="simple-icon-control-end" />
          </template>
        </b-pagination>

        <!-- <b-alert v-if="bootstrapTable.selected.length>0" show variant="primary">Selected Items :<br/><pre>{{ bootstrapTable.selected }}</pre></b-alert> -->
      </b-colxx>
    </b-row>
  </div>
</template>
<script>
import Vue from 'vue'
import { mapGetters, mapMutations } from 'vuex'
import { Notyf } from 'notyf'
import 'notyf/notyf.min.css'

export default {
  components: {},
  data() {
    return {
      user: {},
      items: [{}],
      currentPage: 1,
      perPage: 6,
      totalRows: 0,
      subscribed: true,
      bootstrapTable: {
        selected: [],
        selectMode: 'multi',
        fields: [
          {
            key: 'site',
            label: 'Site',
            sortable: true,
            sortDirection: 'desc',
            tdClass: 'list-item-heading',
          },
          {
            key: 'link',
            label: 'Link',
            sortable: true,
            tdClass: 'text-muted',
          },
          {
            key: 'interval',
            label: 'Interval',
            sortable: true,
            tdClass: 'text-muted',
          },
        ],
      },
      selectedRss: {},
      states: [
        { label: 'Activer', value: true },
        { label: 'Désactiver', value: false },
      ],
      newRss: {
        link: '',
        site: '',
        interval: '60',
      },
    }
  },
  methods: {
    onPaginationData(paginationData) {
      this.$refs.pagination.setPaginationData(paginationData)
    },
    history(id) {
      // console.log("id", id)
    },
    onChangePage(page) {
      this.$refs.vuetable.changePage(page)
    },
    rowSelected(items) {
      this.bootstrapTable.selected = items
      this.selectedUser = items[0]
    },
    async dataProvider(ctx) {
      return await Vue.prototype.$http
        .get('http://localhost:3000/api/rss')
        .then((result) => result.data)
        .then((data) => {
          this.currentPage = data.current_page
          this.perPage = data.per_page
          this.totalRows = data.total
          this.items = data
          return this.items
        })
        .catch((_error) => {
          return []
        })
    },
    apiParamsConverter(params) {
      let apiParams = {}
      if (params.perPage !== 0) {
        apiParams.per_page = params.perPage
      }
      if (params.currentPage >= 1) {
        apiParams.page = params.currentPage
      }
      if (params.sortBy.length > 0) {
        apiParams.sort = `${params.sortBy}|${params.sortDesc ? 'desc' : 'asc'}`
      }
      if (params.filter.length > 0) {
        // Optional
      }
      return apiParams
    },
    hideModal(refname) {
      this.$refs[refname].hide()
      this.dataProvider()
    },
    addNotification(type, title, message) {
      this.$notify(type, title, message, { duration: 3000, permanent: false })
    },
    updateRsses() {
      this.hideModal('modalright')
      Vue.prototype.$http
        .patch(
          'http://localhost:3000/api/rss/' + this.bootstrapTable.selected[0].id,
          this.bootstrapTable.selected[0]
        )
        .then((res) => {
          // console.log(res)
        })
        .catch((err) => {
          // console.log(err)
        })
    },
    deleteRsses() {
      this.hideModal('modalbasic')
      this.bootstrapTable.selected.forEach((c) => {
        Vue.prototype.$http
          .delete('http://localhost:3000/api/rss/' + c.id)
          .then((res) => {
            const index = this.items.indexOf(c)
            if (index > -1) {
              this.items.splice(index, 1)
            }
            this.addNotification('success', 'suppression', 'rss deleted')
          })
      })
      this.dataProvider()
    },
    addRss() {
      Vue.prototype.$http
        .post('http://localhost:3000/api/rss/', this.newRss)
        .then((res) => {
          // console.log(res)
          // console.log(this.newRss)
        })
        .catch((err) => {
          // console.log(err)
        })
    },
  },
  computed: {
    ...mapGetters({
      currentUser: 'currentUser',
    }),
  },
  mounted() {
    this.dataProvider()
    if (this.currentUser) {
      Vue.prototype.$http
        .get(`http://localhost:3000/api/users/${this.currentUser.id}`)
        .then((result) => result.data)
        .then((data) => {
          this.user = data
          // console.log('user', this.user)
          // this.items = this.items.filter(i => {
          //   if (this.currentUser.role === false) {
          //     if (i.is_active === true) {
          //       return i
          //     }
          //   } else {
          //     return i
          //   }
          // })
          // console.log("apres filter", this.items)
          return this.user
        })
        .catch((_error) => {
          return []
        })
    }
  },
}
</script>
